#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    cin>>t;
    for(int iter=0; iter<t; iter++)
    {
        int n, m;
        cin>>n>>m;
        long long a[n];
        long long b[m];
        for(int i=0; i<n; i++)
            cin>>a[i];
        for(int i=0; i<m; i++)
            cin>>b[i];
        int mini=0;
        for(int i=1; i<n; i++)
        {
            if(a[i]<a[mini])
                mini=i;
        }
        long long aald=a[mini];
        for(int i=0; i<n; i++)
            a[i]-=aald;
        long long d=a[0];
        for(int i=1; i<n; i++)
        {
            if(a[i]!=0)
                d=__gcd(d, a[i]);
        }
        bool u=true;
        for(int i=0; i<m && u; i++)
            if((b[i]-aald)%d == 0)
        {
            cout<<0<<endl;
            u=false;
        }
        if(u)
            cout<<1<<endl;
    }
}